package sun.java2d.opengl;

import java.awt.image.AffineTransformOp;
import java.awt.image.BufferedImageOp;
import java.awt.image.BufferedImage;
import sun.java2d.SurfaceData;
import sun.java2d.loops.TransformBlit;
import java.awt.Color;
import java.awt.geom.AffineTransform;
import java.awt.Image;
import sun.java2d.SunGraphics2D;
import sun.java2d.pipe.DrawImage;

public class OGLDrawImage extends DrawImage
{
    public OGLDrawImage() {
    }
    
    @Override
    protected void renderImageXform(SunGraphics2D sg, Image image, AffineTransform tx, int interpType, int sx1, int sy1, int sx2, int sy2, Color bgColor) {
        if (interpType != 3) {
            SurfaceData surfaceData = sg.surfaceData;
            SurfaceData sourceSurfaceData = surfaceData.getSourceSurfaceData(image, 4, sg.imageComp, bgColor);
            if (sourceSurfaceData != null && !DrawImage.isBgOperation(sourceSurfaceData, bgColor) && (sourceSurfaceData.getSurfaceType() == OGLSurfaceData.OpenGLTexture || sourceSurfaceData.getSurfaceType() == OGLSurfaceData.OpenGLSurfaceRTT || interpType == 1)) {
                TransformBlit fromCache = TransformBlit.getFromCache(sourceSurfaceData.getSurfaceType(), sg.imageComp, surfaceData.getSurfaceType());
                if (fromCache != null) {
                    fromCache.Transform(sourceSurfaceData, surfaceData, sg.composite, sg.getCompClip(), tx, interpType, sx1, sy1, 0, 0, sx2 - sx1, sy2 - sy1);
                    return;
                }
            }
        }
        super.renderImageXform(sg, image, tx, interpType, sx1, sy1, sx2, sy2, bgColor);
    }
    
    @Override
    public void transformImage(SunGraphics2D sunGraphics2D, BufferedImage filter, BufferedImageOp bufferedImageOp, int n, int n2) {
        if (bufferedImageOp != null) {
            if ((bufferedImageOp instanceof AffineTransformOp)) {
                AffineTransformOp affineTransformOp = (AffineTransformOp)bufferedImageOp;
                super.transformImage(sunGraphics2D, filter, n, n2, affineTransformOp.getTransform(), affineTransformOp.getInterpolationType());
                return;
            }
            if (OGLBufImgOps.renderImageWithOp(sunGraphics2D, filter, bufferedImageOp, n, n2)) {
                return;
            }
            filter = bufferedImageOp.filter(filter, null);
        }
        this.copyImage(sunGraphics2D, filter, n, n2, null);
    }
}
